## Rocket

BETA RELEASE, gameplay is functional but animations/general visual polish need work.
[![](https://i.imgur.com/vLXTJLY.jpg)]()
[![](https://i.imgur.com/3Q0wCWP.png)]()
	
Original Concept Art by bruh#6900
[![](https://i.imgur.com/P2GpdDk.png)]()

If you have any feedback/suggestions, open an issue on the Github page, or join the discord at https://discord.gg/pKE3QCEsxG

- Stuff not mentioned in-game:
	- Rocket Jumping
		- Maintain momentum by either inputting in the direction of your jump trajectory, or by letting go of the movement keys.
		- Can gradually turn without losing speed.
		
	- Rocket Launcher
		- Rocket knockback scales with enemy mass when hitting non-boss enemies (up to 250kg, Brass Contraption weight)
		
	- SAM Launcher
		- Rockets have a much smaller blast radius compared to stock.
	
	- Remote Detonator
		- Removes blast falloff from explosions.
		
	- Bombing Run
		- Crit Chance is converted to crit damage when using this skill.
		
	- Rapid Rearm
		- Rockets have less knockback.

## To Do

- Balance
- Add non-placeholder animations
- Add non-placeholder skill icons
- Custom projectile models.

## Installation
Drop the dll into \BepInEx\plugins\

## Credits

- Moffein (Coding)
- TimeSweeper (Henry template, animation, getting the model working in-game)
- SkeletorChampion (Model)
- MoistyBoy (UES Prime's Rocket)
- bruh#6900 (Original Concept Art)
- DaPedro#2713 (Skill Icons)

- Sounds taken from:
	- Reflex Arena
	- Quake Champions
	- Risk of Rain 1
	- TF2
	- Dirty Bomb

## Changelog

`0.5.5`

- Updated CachedName to be the same as what's listed on ModdedCharacterEclipseFix.

`0.5.4`

- Remembered to set CachedName field in SurvivorDef. Hopefully this will fix Eclipse progress not saving.
- Fixed M2 being broken online due to a recent update.
- Fixed Nitro Chage not sticking to walls online.

`0.5.3`

- HG4 Rocket Launcher
	- Increased damage from 520% -> 570%
	
- HG4 SAM Launcher
	- Reduced damage from 650% -> 570%
	
	*The SAM Launcher ended up getting buffed too much over the past few updates. Homing and airshot bonus alone are enough to overcome its -45% AoE downside.*

`0.5.2`

- Moved aimOrigin back slightly to reduce instances where rockets go through walls at close range.
- Updated Nitro Charge icon.

`0.5.1`

- Fixed Bombing Run damage not getting multiplied by your damage stat. (from 0.5.0)

`0.5.0`

- Added skill icons (Thanks DaPedro!)
- Enemy knockback scaling now only scales up to 250kg (Brass Contraption weight)
	- Golems can still be launched, but they won't go as far as before.
- Removed Concussion Blast
- Added Nitro Charge (Default Utility)
	- TODO: New icon
	- Toss an explosive charge. Detonate it with Remote Detonator for 1000% damage.
	- Knockback is the same as Concussion Blast (but does not get increased by Remote Detonator).
	- Can have up to 1 (+1 per Utility charge) active. Going above this limit will detonate your earliest one.
	
	*Modded characters have too many debuffs, and Rocket's Conc nade debuff was very niche and was only really useful for himself, as opposed to something like Sniper's Spotter where the whole team can benefit from it. Additionally, the skill felt pretty lackluster compared to Bombing Run.*
	
`0.4.0`

- Added aerial pose (Thanks TimeSweeper!)
- Remote Detonator
	- Changed explosion SFX.
	- Changed network code. Let me know if this improves/worsens online responsiveness.
- Concussion Blast
	- Changed VFX.

`0.3.4`

- Added config to disable HG4 SAM Launcher homing.

`0.3.3`

- Remembered to include the dll.

`0.3.2`

- HG4 SAM Launcher
	- Increased blast radius from 4m -> 4.5m
	- Reduced lockon angle from 20 degrees -> 12 degrees
	- Increased lockon turn speed from 50 -> 60
	- Now only attempts to lock on to targets within LoS.
	- Now prioritizes targets solely based on angle, to reduce instances where it will swerve towards a completely different target.
	
	*Lockon tolerance is tighter, but rockets will be more consistent at actually locking on to relevant things.*
	
- Remote Detonator
	- Increased damage and AoE bonuses from +30% -> +50%
		- Force multiplier remains at +30% since it already is pretty strong.
	- Increased SAM Launcher AoE from 8m -> 10m
	
	*A common feedback with this skill was that it was really good for mobility but not very impactful mid-combat.*

`0.3.1`

- Pocket ICBM
	- Extra rockets no longer have knockback.
		- Can be re-enabled in the config.

`0.3.0`

- HG4 SAM Launcher
	- Reduced blast radius from 5m -> 4m
	- Reduced rocket targetfinder range from 80m -> 60m
	
	*Previous numbers were too good at long range, being able to easily hit targets even if your aim was way off.*

`0.2.19`

- Fixed ICBM damage mult being applied when ICBM Config is disabled.
- Fixed Special not benefitting from the ICBM damage mult.

`0.2.18`

- HG4 SAM Launcher
	- Increased damage from 600% -> 650%
	- Increased blast radius from 3m -> 5m
		- Note: SAM Launcher has no blast falloff.
	- Rockets now slightly home.
		- Numbers need adjustment (homing strength/range/lockon FOV), give feedback!
	
	*Experimenting with changing up the skill a bit. Unsure about the homing since it makes juggling harder due to autotargeting the center of certain enemies.*

- Pocket ICBM now affects rocket skills.
	- Can be disabled in config.

`0.2.17`

- Fixed Bombing Run immediately getting cancelled by Primary skills.

`0.2.16`

- Fixed outro tokens not showing.

`0.2.15`

- Updated default skin icon(Thanks Timesweeper!)

`0.2.14`

- Fixed internal version number.

`0.2.13`

- Increased Rocket Jump no-momentum-loss angle from +/- 10 -> +/- 20
	- Hoping to make forwards jumping more consistent. Will adjust this further if needed.
- Fixed certain skills getting added to the game's skilldef catalog twice.
- Added Scepter skill.
	- Rocketstorm: doubles Rapid Rearm's rockets fired and fire rate.
- Removed unused Henry assets to reduce filesize.
- Added default skin icon.

`0.2.12`

- Remote Detonator
	- Now detonates all active rockets.
	
	*This should fix the issue where you're able to waste charges on rockets that are flying away into the skybox.*

`0.2.11`

- HG4 SAM Launcher
	- Increased Remote Detonator AoE from 3.9m -> 8m
		- 8m is the radius of the default Primary's rockets WITHOUT Remote Detonator.

- Concussion Blast (Utility)
	- Reduced cooldown from 7s -> 5s
	
- Bombing Run (Utility)
	- Reduced cooldown from 7s -> 5s

- Rapid Rearm (Special)
	- Reduced cooldown from 12s -> 10s

`0.2.10`

- Fixed Rocket being unable to be healed by Heal Drones and HAN-D.
	- Probably fixes a few other bugs related to autotarget skills.

`0.2.9`

- Improved rocket jump consistency.
	- Now uses a proper hitbox overlap check, instead of just calculating distance from the explosion to the player.

`0.2.8`

- Fixed Alt M1 being bugged in multiplayer.
	- Might also result in a few other things being fixed.

`0.2.7`

- Remote Detonator
	- Attempted to improve online responsiveness.
		- Instead of waiting for the EntityState to run on the server, the client will send a command to tell the server to detonate.
			- Not sure if this actually improves things or not. Feedback will be super helpful!
	
- Bombing Run
	- Now only consumes a stock if it hits at least 1 enemy.
	- Increased melee hitbox size from 4.4x4.4x3.2 -> 6x6x4.3
	- Increased blast radius from 8m -> 10m
	
- Additional Notes:
	- Concussion Blast
		- I'm not quite happy with this skill. I feel it's boring compared to Bombing Run.
			- Turn it into an actual grenade/clusterbomb?
		- Could maybe replace it with something else entirely if any ideas come up.
		
	- Rapid Rearm
		- Is this too basic?

`0.2.6`

- Thunderstore release.